//(((((((((((((((((((((((((((O))))))))))))))))))))))))))))//
//                                                        //
//                  TActiveMovie demo                     //
//         Copyright (c) 2001 Michel Fornengo             //
//               All rights reserved.                     //
//                                                        //
// This unit implements the Microsoft ActiveMovie control //
//                                                        //
// contact: support@delphicity.com                        //
// support: http://www.delphicity.com                     //
//                                                        //
//(((((((((((((((((((((((((((O))))))))))))))))))))))))))))//

//---------------------------------------------------------------------------
#include <graphics.hpp>
#include <vcl.h>
#pragma hdrstop

#include "Demo_.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AMovie"
#pragma resource "*.dfm"
TForm1 *Form1;
TForm *StillForm;
TImage *StillImage;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   ActiveMovie1->FileName = Edit1->Text;
   ActiveMovie1->OpenSync();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
   ActiveMovie1->Play();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
   ActiveMovie1->Pause ();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
   ActiveMovie1->Stop ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
   ActiveMovie1->Volume = (TrackBar1->Position - TrackBar1->Max) * 200;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar2Change(TObject *Sender)
{
   // The speed rate is a Double value.
   // - normal speed = 1
   // - half-speed = 0.5
   // - 1 1/2 speed = 1.5
   // - etc...
   ActiveMovie1->Rate = 0.5 + ((TrackBar2->Max - TrackBar2->Position) / 200); // Max - Position to reverse direction
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
   ActiveMovie1->FastReverse2 (10);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
   ActiveMovie1->FastForward2 (10);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar4Change(TObject *Sender)
{
   ActiveMovie1->Balance = (25 - TrackBar4->Position) * 400;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   ActiveMovie1->Close ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
   OpenDialog1->FileName = "*.mpg;*.mpeg;*.avi;*.wav;*.mp3;*.asf;*.wmv";
   if (OpenDialog1->Execute()) {
      Edit1->Text = OpenDialog1->FileName;
      ActiveMovie1->FileName = Edit1->Text;
      ActiveMovie1->OpenSync ();
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
   Edit1->Text = "http://www.delphicity.com/amovie/demo.mpeg";
   ActiveMovie1->FileName = Edit1->Text;
   ActiveMovie1->OpenSync();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
   TrackBar2->Position = 400;
   TrackBar2->OnChange (this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   ActiveMovie1->FullScreenMode = CheckBox1->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
   ActiveMovie1->DisplayLogo = CheckBox3->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
   ActiveMovie1->ShowControls = CheckBox2->Checked;
   CheckBox2->Checked = ActiveMovie1->ShowControls; // loopback if ShowControls rejected
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   if (FileExists ("demo.mpeg")) {
      Edit1->Text = ExpandFileName ("demo.mpeg");
   }
   CheckBox2->Checked = ActiveMovie1->ShowControls;
   CheckBox3->Checked = ActiveMovie1->DisplayLogo;
   CheckBox4->Checked = ActiveMovie1->AutoStart;
   CheckBox5->Checked = ActiveMovie1->ShowScrollBars;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
   ActiveMovie1->DisplaySize = TDisplaySize (RadioGroup1->ItemIndex);
   RadioGroup1->ItemIndex = Integer (ActiveMovie1->DisplaySize); // loopback
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ActiveMovie1FullScreenKeyDown(TObject *Sender,
      int VirtualKey, int KeyData)
{
   const int F2 = 113;
   const int F3 = 114;
   const int F4 = 115;
   const int F5 = 116;
   const int F6 = 117;
   const int F7 = 118;
   const int F8 = 119;
   const int F11 = 122;
   const int F12 = 123;

   int VolumeStep;

   VolumeStep = 100;
   switch (VirtualKey) {
      case F2: ActiveMovie1->Play (); break;
      case F3: ActiveMovie1->Pause (); break;
      case F4: ActiveMovie1->Stop (); break;

      case F5: ActiveMovie1->FastForward2 (10); break;

      case F6: ActiveMovie1->FastReverse2 (10); break;

      case F7: ActiveMovie1->Rate = ActiveMovie1->Rate + 0.3; break;

      case F8: ActiveMovie1->Rate = ActiveMovie1->Rate - 0.3; break;

      case F11: if ((ActiveMovie1->Volume + VolumeStep) <= 0) {
                   ActiveMovie1->Volume = ActiveMovie1->Volume + VolumeStep;
                } else {
                   ActiveMovie1->Volume = 0;
                } break;

      case F12: if ((ActiveMovie1->Volume + VolumeStep) > -10000) {
                   ActiveMovie1->Volume = ActiveMovie1->Volume - VolumeStep;
                } else {
                   ActiveMovie1->Volume = - 10000;
                } break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ActiveMovie1PositionChange(TObject *Sender,
      double OldTimePosition, double NewTimePosition,
      DWORD OldFramePosition, DWORD NewFramePosition)
{
   if (TrackBar5->Tag == 0) {
      TrackBar5->Tag = 1;
      TrackBar5->Position = NewTimePosition * TrackBar5->Max / ActiveMovie1->TotalTime;
      TrackBar5->Tag = 0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar5Change(TObject *Sender)
{
   if (TrackBar5->Tag == 0) {
      ActiveMovie1->TimePosition = TrackBar5->Position * ActiveMovie1->TotalTime / TrackBar5->Max;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar7Change(TObject *Sender)
{
   ActiveMovie1->ScrollHorz (TrackBar7->Min, TrackBar7->Position, TrackBar7->Max);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar6Change(TObject *Sender)
{
   ActiveMovie1->ScrollVert (TrackBar6->Min, TrackBar6->Position, TrackBar6->Max);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox4Click(TObject *Sender)
{
   ActiveMovie1->AutoStart = CheckBox4->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox5Click(TObject *Sender)
{
   ActiveMovie1->ShowScrollBars = CheckBox5->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
   TrackBar6->Position = 20; // the middle between Min and Max
   TrackBar6Change (this);
   TrackBar7->Position = 20;
   TrackBar7Change (this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
   if (StillForm == NULL) {
      StillForm = new TForm (this);
      StillForm->HorzScrollBar->Visible = false;
      StillForm->VertScrollBar->Visible = false;
      StillForm->Position = poDefault;
      StillForm->FormStyle = fsStayOnTop;
      StillImage = new TImage (StillForm);
      StillImage->Parent = StillForm;
   }
   ActiveMovie1->CaptureFrameToImage (StillImage);
   StillForm->ClientWidth = StillImage->Width;
   StillForm->ClientHeight = StillImage->Height;
   StillForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ActiveMovie1OpenStateChange(TObject *Sender,
      int OldState, int NewState)
{
   if (NewState == nsOpen) {
      BitBtn1->Enabled = True;
   }
   else {
      BitBtn1->Enabled = False;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar3Change(TObject *Sender)
{
   ActiveMovie1->ZoomSize = TrackBar3->Position;         
}
//---------------------------------------------------------------------------
